

#ifndef _HEXDISPLAY_H_
	#define _HEXDISPLAY_H_

#include <SDL2/SDL.h>

#include "RGBColor.h"

class HexDisplay {

	public:
		HexDisplay();

	public:

		// now we just set the radius once
		// instantiating a member for a given radius
		// so the floating point math only needs to be done once for a whole grid

		void setRadius(double r);

		void setLineColor(RGBColor c)  { LineColor = c; }
		void setFillColor(RGBColor f)  { FillColor = f; }
		void setFillEnabled(bool f) { FillEnabled = f; }


		void DrawHex(SDL_Renderer* renderer, int location_x, int location_y);
		void DrawInvertedHex(SDL_Renderer* renderer, int location_x, int location_y);

	private:
		double Radius;

		bool FillEnabled;

		RGBColor LineColor;
		RGBColor FillColor;

		// helper vars stored to avoid recalculating
		// calculate once to avoid wasting cpu, and we only need the rounded int values anyway
		int Half_R;
		int Half_R_Sqrt3;
};

#endif
