
#ifndef __TERRAINMAP_H
#define __TERRAINMAP_H

#include "RGBColor.h"

class RealmColorMap {
private:

	// array of color info for each spot
	RGBColor* ColorData;


	// steps from the center to edge of the terrain map.
	// ex: RadiusSize of 1 means 7 NumHexes in the map (distance 1 from center to edge)
	// RadiusSize of 2 means 19 hexes, etc...
	int RadiusSize;

	// total number of hexes in the map
	int NumHexes;

	bool Updated;

public:

	RealmColorMap(int radiussize);
	~RealmColorMap();

	int getNumHexes() { return NumHexes; }


	// funections to set / get the terrain at a given location
	RGBColor getHex(int idx) { return ColorData[idx]; }

	void setHex(int idx, RGBColor val);
	bool hasUpdated();
};

#endif // __TERRAINMAP_H
