#include "RealmObject.h"
#include "SceneMoveAnimator.h"
#include "RealmObjectType.h"

void RealmObject::init(RealmObjectType* otype, int w, int h) {
	object_type = otype;
	width = w; height = h;
	object_animator = nullptr;
}

void RealmObject::beginMove(HexSpiralCoordinate target) {
	if (object_animator) {
		object_animator->beginMove(target);
	}
}

XYLocation RealmObject::getScreenLocation() {
	if (object_animator)
		return object_animator->getScreenLocation();
}

double RealmObject::getScaleFactor() {
	return object_animator->getZoomScale();
}

void RealmObject::update()
{
	screenlocation = this->getScreenLocation();
	scalefactor = this->getScaleFactor();
	if (object_animator) {
		object_animator->advanceFrame();
	}
}

void RealmObject::resetUpdateFlags() {
	if (object_animator) {
		object_animator->resetFrameUpdate();
	}
}

void RealmObject::draw(SDL_Renderer* renderer) {
	object_type->drawAt(renderer, screenlocation, width * scalefactor, height * scalefactor);
}
