#ifndef __REALMOBJECT_H
	#define __REALMOBJECT_H

#include <SDL2/SDL.h>
#include "XYLocation.h"
#include "HexSpiralCoordinate.h"

class RealmObjectType;
class RealmSceneView;
class SceneMoveAnimator;

class RealmObject {
	private:
		// screenlocation and scalefactor are calculated during update() method,
		// and their values are used during the draw() phase
		XYLocation screenlocation;
		double scalefactor;
	protected:
		RealmObjectType *object_type;

		int width, height;

		SceneMoveAnimator* object_animator;

		virtual double getScaleFactor();
		virtual XYLocation getScreenLocation();

		void beginMove(HexSpiralCoordinate target);

	public:
		void init(RealmObjectType* otype, int w, int h);
		void setObjectAnimator(SceneMoveAnimator* oa) { object_animator = oa; }

		SceneMoveAnimator* getAnimator() { return object_animator; }

		void update();
		void resetUpdateFlags();
		void draw(SDL_Renderer* renderer);
};

#endif // __REALMOBJECT_H
