#include "RealmSceneBackgroundRepository.h"
#include "RealmSceneElevationMap.h"
#include "RealmSceneBackground.h"

RealmSceneBackground* RealmSceneBackgroundRepository::findSceneBackground(RealmMapKey mapkey) {
	auto result = SceneBackgrounds.find(mapkey);
	if (result != SceneBackgrounds.end()) {
		return result->second;
	} else {
		return nullptr;
	}
}

RealmSceneBackground* RealmSceneBackgroundRepository::makeSceneBackground(RealmSceneElevationMap* emap) {
	RealmMapKey mapkey = emap->getMapKey();
	bool inverted = mapkey.isInverted();
	int radius = mapkey.MapCenterKey.displaylevel < 4 ? 13 : 4;

	RealmSceneBackground* scenemap = new RealmSceneBackground(mapkey.CenterSpiralOffset, emap, radius, inverted);

	SceneBackgrounds.insert(std::pair<RealmMapKey, RealmSceneBackground*> (mapkey, scenemap) );

}

