
#ifndef __SCENEOBJECTCOLLECTION_H
	#define __SCENEOBJECTCOLLECTION_H

#include <forward_list>

class RealmSceneObject;
class RealmWorldObject;
class RealmSceneView;
class SDL_Renderer;
class SceneMoveAnimator;

class SceneObjectCollection {

	public:
		SceneObjectCollection();

		// Based on the object's location and zoom view mode,
		// add the object to the appropriate array collection for the given location
		void addObject(RealmSceneObject* object);


		void addWorldObject(RealmWorldObject* object);
		void clearWorldObjects();

		void updateRealmSceneView(RealmSceneView* realm_scene_view);


		void updateObjects();
		void resetUpdateFlags();

		void drawObjects(SDL_Renderer *renderer);
		void cleanupObjects();

		int getCount() { return object_count; }
	private:
		std::forward_list<RealmSceneObject *> objects;
		std::forward_list<SceneMoveAnimator *> animators;

		int object_count;

		// world objects to be dynamically mapped into the scene

		std::forward_list<RealmWorldObject *> world_objects;

		RealmSceneView* realm_scene_view;
};

#endif // __SCENEOBJECTCOLLECTION_H
